SystemOrganization addCategory: #'Mars-Gtk'!
SystemOrganization addCategory: #'Mars-Gtk-Announcements'!
SystemOrganization addCategory: #'Mars-Gtk-Base'!
SystemOrganization addCategory: #'Mars-Gtk-Events'!
SystemOrganization addCategory: #'Mars-Gtk-Layouts'!
SystemOrganization addCategory: #'Mars-Gtk-Menues'!
SystemOrganization addCategory: #'Mars-Gtk-TextHandling'!
SystemOrganization addCategory: #'Mars-Gtk-Tools'!
SystemOrganization addCategory: #'Mars-Gtk-Widgets'!

Trait named: #GtkEditable
	uses: {}
	category: 'Mars-Gtk'!

!GtkEditable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 16:15'!
selectedText
	| start end startInt endInt res |
	res := Alien newC: 4.
	start := Alien newC: 4.
	end := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_editable_get_selection_bounds')
		primFFICallResult: res
		with: self handle
		with: start pointer
		with: end pointer.
	res asUnsignedShort > 0 ifTrue: [
		startInt := start asUnsignedInt.
		endInt := end asUnsignedInt.
		^self text copyFrom: startInt + 1 to: endInt
	] ifFalse: [ 
		^'' 
	]! !

Trait named: #TGtkContainer
	uses: {}
	category: 'Mars-Gtk-Widgets'!

!TGtkContainer methodsFor: 'gtk-private' stamp: 'GuillermoPolito 2/29/2012 16:22'!
gtkAddChild: aWidget
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_container_add')
		primFFICallResult: (Alien new: 4)
		with: self handle
		with: aWidget handle.! !

Trait named: #TGtkWidget
	uses: {}
	category: 'Mars-Gtk-Widgets'!

!TGtkWidget methodsFor: 'gtk-private' stamp: 'GuillermoPolito 2/29/2012 16:45'!
gtkAddToContainer: gtkContainer
	self logCr: self printString , ' ',  self hash asString, ' adding to ', gtkContainer printString, ' ',  gtkContainer hash asString.
	gtkContainer gtkAddChild: self! !

SharedPool subclass: #GtkConstants
	instanceVariableNames: ''
	classVariableNames: 'PolicyTypeAlways PolicyTypeAutomatic PolicyTypeNever'
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkConstants class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 16:19'!
initialize 
	"self initialize"
	PolicyTypeAlways := 0.
	PolicyTypeAutomatic := 1.
	PolicyTypeNever := 2.! !

MToolkit subclass: #GtkToolkit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Base'!

!GtkToolkit class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 21:37'!
classFor: aClass
	^ self environment at: ('Gtk', aClass name allButFirst) asSymbol.! !

!GtkToolkit class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 21:35'!
isActive
	^ OSPlatform isUnix or: [ OSPlatform isWin32 ].! !

Callback subclass: #GtkCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkCallback methodsFor: 'signatures' stamp: 'EstebanLorenzano 1/19/2012 08:53'!
voidRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void)' abi: 'IA32'>
	block value.
	^nil asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/20/2012 18:28'!
voidstarIntCharstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, int, char *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (spAlien unsignedLongAt: 5)
		value: (spAlien stringAt: 9).
	
	^nil asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/20/2012 00:26'!
voidstarIntIntRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, int, int)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (spAlien unsignedLongAt: 5)
		value: (spAlien unsignedLongAt: 9).
	
	^nil! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/20/2012 00:26'!
voidstarIntvoidstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, int, void *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (spAlien unsignedLongAt: 5)
		value: (Alien forPointer: (spAlien unsignedLongAt: 9)).
	
	^nil! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstarRetint: callbackContext sp: spAlien
	<signature: 'void (*)(void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))) asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstareventbuttonstarvoidstarRetint: callbackContext sp: spAlien
	<signature: 'int (*)(void *, eventButton *, void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5)) asGtkEventButton
		value: (Alien forPointer: (spAlien unsignedLongAt: 9))) 
			asAlien.! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/19/2012 23:45'!
voidstareventbuttonstarvoidstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, eventButton *, void *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5)) asGtkEventButton
		value: (Alien forPointer: (spAlien unsignedLongAt: 9)).
	
	^nil! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstarintvoidstarRetint: callbackContext sp: spAlien
	<signature: 'int (*)(void *, int, void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (spAlien unsignedLongAt: 5)
		value: (Alien forPointer: (spAlien unsignedLongAt: 9)) ) asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstarvoidstarIntvoidstarRetint: callbackContext sp: spAlien
	<signature: 'int (*)(void *, void *, int, void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5))
		value: (spAlien unsignedLongAt: 9)
		value: (Alien forPointer: (spAlien unsignedLongAt: 13))) asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/20/2012 00:44'!
voidstarvoidstarIntvoidstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, void *, int, void *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5))
		value: (spAlien unsignedLongAt: 9)
		value: (Alien forPointer: (spAlien unsignedLongAt: 13)).
	
	^nil! !

!GtkCallback methodsFor: 'signatures' stamp: 'EstebanLorenzano 1/19/2012 09:14'!
voidstarvoidstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, void *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5)).	
	
	^nil asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstarvoidstarintintintvoidstarRetint: callbackContext sp: spAlien
	<signature: 'int (*)(void *, void *, int, int, int, void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block valueWithArguments: {
		Alien forPointer: (spAlien unsignedLongAt: 1) .
		Alien forPointer: (spAlien unsignedLongAt: 5) .
		spAlien unsignedLongAt: 9 .
		spAlien unsignedLongAt: 13 .
		spAlien unsignedLongAt: 17 .
		Alien forPointer: (spAlien unsignedLongAt: 21) }) asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'GuillermoPolito 1/30/2012 22:55'!
voidstarvoidstarvoidstarRetint: callbackContext sp: spAlien
	<signature: 'int (*)(void *, void *, void *)' abi: 'IA32'>
	
	^callbackContext wordResult: (block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5))
		value: (Alien forPointer: (spAlien unsignedLongAt: 9)) ) asAlien! !

!GtkCallback methodsFor: 'signatures' stamp: 'EstebanLorenzano 1/19/2012 09:18'!
voidstarvoidstarvoidstarRetvoid: callbackContext sp: spAlien
	<signature: 'void (*)(void *, void *, void *)' abi: 'IA32'>
	
	block 
		value: (Alien forPointer: (spAlien unsignedLongAt: 1))
		value: (Alien forPointer: (spAlien unsignedLongAt: 5))
		value: (Alien forPointer: (spAlien unsignedLongAt: 9)).	
	
	^nil asAlien! !

Alien variableByteSubclass: #GtkPopulatePopupCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkPopulatePopupCallback class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 14:52'!
dataSize
	^12! !

!GtkPopulatePopupCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 14:52'!
data
	^Alien forPointer: (self unsignedLongAt: 9)! !

!GtkPopulatePopupCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 14:52'!
entry
	^Alien forPointer: (self unsignedLongAt: 1)! !

!GtkPopulatePopupCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 14:52'!
menu
	^Alien forPointer: (self unsignedLongAt: 5)! !

Alien variableByteSubclass: #GtkSignalCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkSignalCallback class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/17/2012 19:29'!
dataSize
	^12! !

!GtkSignalCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/17/2012 19:29'!
data
	^Alien forPointer: (self unsignedLongAt: 9)! !

!GtkSignalCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/17/2012 19:29'!
event
	^Alien forPointer: (self unsignedLongAt: 5)! !

!GtkSignalCallback methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/17/2012 19:29'!
widget
	^Alien forPointer: (self unsignedLongAt: 1)! !

Alien variableByteSubclass: #GtkTextIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkTextIterator commentStamp: 'GuillermoPolito 1/19/2012 19:06' prior: 0!
gpointer dummy1;
  gpointer dummy2;
  gint dummy3;
  gint dummy4;
  gint dummy5;
  gint dummy6;
  gint dummy7;
  gint dummy8;
  gpointer dummy9;
  gpointer dummy10;
  gint dummy11;
  gint dummy12;
  /* padding */
  gint dummy13;
  gpointer dummy14;!

!GtkTextIterator class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:07'!
dataSize
	^56! !

Announcement subclass: #MarsPropertyHasChanged
	instanceVariableNames: 'property'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Announcements'!

!MarsPropertyHasChanged class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/30/2012 17:31'!
property: aProperty
	^self new property: aProperty! !

!MarsPropertyHasChanged methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:32'!
property
	^property! !

!MarsPropertyHasChanged methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:32'!
property: aProperty
	property := aProperty! !

ExternalLibrary subclass: #GtkLibrary
	instanceVariableNames: 'registry'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkLibrary class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2012 09:45'!
moduleName 
	OSPlatform isUnix ifTrue: [ ^'libgtk-x11-2.0' ].
	OSPlatform isMacOS ifTrue: [ ^'libgtk-quartz-2.0.0.dylib' ].

	self error: 'Gtk not defined for this platform'! !

!GtkLibrary class methodsFor: 'accessing' stamp: 'GuillermoPolito 1/17/2012 19:16'!
reset
	UniqueInstance := nil.! !

!GtkLibrary class methodsFor: 'accessing' stamp: 'GuillermoPolito 1/17/2012 19:14'!
uniqueInstance
	^UniqueInstance ifNil: [ UniqueInstance := self new ]! !

!GtkLibrary methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2012 08:01'!
alienMethodNamed: aString 
	^Alien lookup: aString inLibrary: self name.
	! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 20:11'!
eventsPending
	^((self alienMethodNamed: 'gtk_events_pending')
			primFFICallResult: (Alien new: 4)) asBoolean.! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/17/2012 19:15'!
init
	(self alienMethodNamed: 'gtk_init')
		primFFICallResult: nil
		with: 0 
		with: 0.! !

!GtkLibrary methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/20/2012 18:22'!
initialize
	super initialize.
	registry := Set new.! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/17/2012 21:17'!
main
	(self alienMethodNamed: 'gtk_main')
		primFFICallResult: nil asAlien! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:00'!
mainIteration
	| result |
	(result := Alien newC: 4) releaseAfter: [
		(self alienMethodNamed: 'gtk_main_iteration')
			primFFICallResult: result.
		^result
	]! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:00'!
mainIterationDo: blocking
	| result |
	(result := Alien newC: 4) releaseAfter: [
		(self alienMethodNamed: 'gtk_main_iteration_do')
			primFFICallResult: result
			with: blocking asAlien.
		^result
	]! !

!GtkLibrary methodsFor: 'widget-registry' stamp: 'GuillermoPolito 1/30/2012 15:32'!
registerWidget: aWidget
	"aWidget onDeleteEvent: [ :widget :event :data | self widgetDeleted: aWidget. false ]."
	registry add: aWidget.! !

!GtkLibrary methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 22:52'!
signalConnectWidget: aPointer event: eventString callback: aCallback data: someData
	| result eventStringAlien dataAlien |
	(eventStringAlien := eventString asAlien) releaseAfter: [
	(dataAlien := someData asAlien) releaseAfter: [
	(result := Alien newC: 4) releaseAfter: [
		(self alienMethodNamed: 'g_signal_connect_data')
			primFFICallResult: result
			with: aPointer
			with: eventStringAlien pointer
			with: aCallback thunk
			with: ((dataAlien isKindOf: Alien) ifTrue: [ dataAlien pointer] ifFalse: [ 0 ])
			with: 0
			with: 0.
		^result
	]]]! !

!GtkLibrary methodsFor: 'widget-registry' stamp: 'GuillermoPolito 1/20/2012 18:40'!
widgetDeleted: aWidget
	registry remove: aWidget.! !

Object subclass: #GtkAlienExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk'!

!GtkAlienExample class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2012 08:56'!
run1
	"HAAAAAAA.. WE WOON"

	| window data cb button end |
	
GtkLibrary reset.
GtkLibrary uniqueInstance init.

window := GtkLibrary uniqueInstance windowNew.

"GtkLibrary uniqueInstance 
	signalConnectWidget: window pointer
	event: 'delete-event' 
	callback: [:args :result|
			Browser open.
			result returnInteger: 1 ] 
	data: nil."

cb := nil.

button := GtkLibrary uniqueInstance buttonNewWithLabel: 'Hola GTK puto!!'.
GtkLibrary uniqueInstance
	signalConnectWidget: button
	event: 'clicked' 
	callback: (cb := (GtkCallback
			signature: 'void (*)(void)'
			block: [ Transcript show: 'OK'; cr ]))
	data: (Alien newC: 4).
	
GtkLibrary uniqueInstance
	container: window add: button.

GtkLibrary uniqueInstance showWidget: button.
GtkLibrary uniqueInstance showWidget: window.

"GtkLibrary uniqueInstance main."

"GtkLibrary uniqueInstance mainIteration."

end := false.
[[end] whileFalse: [ 
	GtkLibrary uniqueInstance mainIterationDo: false.
	(Delay forMilliseconds: 50) wait ]] 
		forkNamed: 'GTKMainLoop'.

"end := true"! !

!GtkAlienExample class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 01:40'!
run2
	"HAAAAAAA.. WE WOON"

	| window data cb button end |
	
	GtkLibrary reset.
	GtkLibrary uniqueInstance init.

	window := GtkWindow new.
	button := GtkButton new.
	button onClick: [ UIManager inform: 'click!!' ].
	window addChild: button.
	window show.

	end := false.
	[[end] whileFalse: [ 
		GtkLibrary uniqueInstance mainIterationDo: false.
		(Delay forMilliseconds: 50) wait ]] 
			forkNamed: 'GTKMainLoop'.

	"end := true"! !

!GtkAlienExample class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/3/2012 19:19'!
run3
	"HAAAAAAA.. WE WOON"

	| window button pane txt |
	
	GtkLibrary reset.
	GtkLibrary uniqueInstance init.

	window := GtkWindow new.
	window title: 'Hello GTK 2 !!'.
	pane := GtkVerticalLayout new.
	txt := GtkEntry new.
	button := GtkButton new.
	button onClick: [ GtkWindow new title: txt text; show ].
	window addChild: pane.
	pane addChild: txt.
	pane addChild: button.
	window show.

	GtkLibrary uniqueInstance main.
	"GtkEventLoop start."
	"GtkEventLoop stop."! !

Object subclass: #GtkBrowser
	instanceVariableNames: 'announcer selectedCategory selectedBehavior selectedMethod announcers selectedMethodSource mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Tools'!

!GtkBrowser methodsFor: 'announcements' stamp: 'GuillermoPolito 1/30/2012 17:53'!
addAnnouncer: anAnnouncer
	announcers add: anAnnouncer! !

!GtkBrowser methodsFor: 'announcements' stamp: 'GuillermoPolito 1/30/2012 17:52'!
announce: anAnnouncement
	announcers do: [ :ann | ann announce: anAnnouncement ]! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:53'!
behaviors
	^selectedCategory ifNil: [ #() ] ifNotNil: [ SystemOrganization classesInCategory: selectedCategory ]
	! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:47'!
categories
	^SystemOrganization categories! !

!GtkBrowser methodsFor: 'behavior' stamp: 'NicolasPasserini 2/2/2012 18:35'!
classMode
	self mode: GtkBrowserClassMode new.! !

!GtkBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/16/2012 17:24'!
createBehaviorsPanel
	| behaviorsPanel behaviorsList buttonsPanel |
	behaviorsPanel := GtkVerticalLayout new.

	behaviorsList := GtkList new model: self; 
		bindContentsOn: #behaviors; 
		bindSelectedItemOn: #selectedBehavior.

	behaviorsPanel addChild: behaviorsList scrollable.
	
	buttonsPanel := GtkHorizontalLayout new.
	buttonsPanel addChild: (GtkButton new label: 'Instance'; onClick: [ self instanceMode ]).
	buttonsPanel addChild: (GtkButton new label: '?').
	buttonsPanel addChild: (GtkButton new label: 'Class'; onClick: [ self classMode ]).
	behaviorsPanel addChild: buttonsPanel.

	^ behaviorsPanel.
! !

!GtkBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/16/2012 17:24'!
createListsPanel
	| listsPanel behaviorsList |
	listsPanel := GtkHorizontalLayout new.
	listsPanel addChild: (GtkList new model: self; bindContentsOn: #categories; bindSelectedItemOn: #selectedCategory) scrollable.
	
	listsPanel addChild: self createBehaviorsPanel .
	
	listsPanel addChild: (GtkList new model: self; bindContentsOn: #methods; bindSelectedItemOn: #selectedMethod) scrollable.
	^ listsPanel.
! !

!GtkBrowser methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 17:54'!
initialize
	super initialize.
	announcers := Set new.! !

!GtkBrowser methodsFor: 'behavior' stamp: 'NicolasPasserini 2/2/2012 18:35'!
instanceMode
	self mode: GtkBrowserInstanceMode new.! !

!GtkBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 18:39'!
methods
	^selectedBehavior ifNil: [ #() ] ifNotNil: [ self mode methodsFor: selectedBehavior ]! !

!GtkBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 18:30'!
mode
	^ mode ifNil: [ mode := GtkBrowserInstanceMode new ]
! !

!GtkBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 18:41'!
mode: anObject
	mode := anObject.
	self announce: (MarsPropertyHasChanged property: #selectedBehavior).
	self announce: (MarsPropertyHasChanged property: #methods).
! !

!GtkBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/29/2012 18:19'!
open
	| window mainPanel methodPane |
	window := GtkWindow new.
	window title: 'Browser'.
	window defaultWidth: 500 height: 400.
	
	mainPanel := GtkVerticalLayout new.
	mainPanel height: 400.
	window addChild: mainPanel.
	
	mainPanel addChild: self createListsPanel.
	mainPanel addChild: (methodPane := GtkTextArea new model: self; bindContentsOn: #selectedMethodSource).	
	
	self announce: (MarsPropertyHasChanged property: #categories).
	
	window show.
	^window! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:29'!
selectedBehavior
	^selectedBehavior
	! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:41'!
selectedBehavior: aBehavior
	selectedBehavior := aBehavior.
	self announce: (MarsPropertyHasChanged property: #selectedBehavior).
	self announce: (MarsPropertyHasChanged property: #methods).
	self selectedMethod: nil.! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:28'!
selectedCategory
	selectedCategory! !

!GtkBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 18:06'!
selectedCategory: aCategory
	selectedCategory := aCategory.
	self announce: (MarsPropertyHasChanged property: #selectedCategory).
	self announce: (MarsPropertyHasChanged property: #behaviors).
	
	self selectedBehavior: nil.
! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:30'!
selectedMethod
	^selectedMethod! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 18:15'!
selectedMethod: aMethod
	selectedMethod := aMethod.
	selectedMethod ifNotNil: 
		[self selectedMethodSource: (selectedBehavior >> selectedMethod) sourceCode asString].
	self announce: (MarsPropertyHasChanged property: #selectedMethod).! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 18:12'!
selectedMethodSource
	^selectedMethodSource! !

!GtkBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 18:07'!
selectedMethodSource: someText
	selectedMethodSource := someText.
	self announce: (MarsPropertyHasChanged property: #selectedMethodSource)! !

Object subclass: #GtkBrowserClassMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Tools'!

!GtkBrowserClassMode methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/5/2012 13:11'!
lookupSelector: aSelector inBehavior: aBehavior
	^ aBehavior theMetaClass >> aSelector! !

!GtkBrowserClassMode methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 18:46'!
methodsFor: selectedBehavior 
	^ selectedBehavior class selectors! !

Object subclass: #GtkBrowserInstanceMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Tools'!

!GtkBrowserInstanceMode methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/5/2012 13:12'!
lookupSelector: aSelector inBehavior: aBehavior
	^ aBehavior >> aSelector! !

!GtkBrowserInstanceMode methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 18:40'!
methodsFor: selectedBehavior 
	^ selectedBehavior selectors! !

Object subclass: #GtkEventButton
	instanceVariableNames: 'alien'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Events'!

!GtkEventButton class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/30/2012 21:59'!
forAlien: anAlien
	^self new
		alien: anAlien;
		yourself! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 22:00'!
alien: anAlien
	alien := anAlien! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 00:00'!
button
	^alien unsignedLongAt: 41! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 23:49'!
eventType
	^alien unsignedLongAt: 1! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 23:51'!
sendEvent
	^(alien unsignedByteAt: 9) > 0! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 00:00'!
state
	^alien unsignedLongAt: 37! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 23:51'!
time
	^alien unsignedLongAt: 13! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 23:52'!
x
	^alien doubleAt: 17! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 00:00'!
xRoot
	^alien unsignedLongAt: 49! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 23:59'!
y
	^alien doubleAt: 25! !

!GtkEventButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 00:00'!
yRoot
	^alien doubleAt: 57! !

Object variableByteSubclass: #GtkEventLoop
	instanceVariableNames: ''
	classVariableNames: 'EventLoop'
	poolDictionaries: ''
	category: 'Mars-Gtk'!

GtkEventLoop class
	instanceVariableNames: 'shouldFinish finished process'!

GtkEventLoop class
	instanceVariableNames: 'shouldFinish finished process'!

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 13:29'!
finished
	^process isNil or: [ process isTerminated or: [ finished ifNil: [ finished := true ] ]]! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 13:23'!
finished: aBoolean
	finished := aBoolean! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2012 09:00'!
isRunning 
	^self finished not! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/5/2012 13:07'!
restart
	self finished ifFalse: [ self stop ].
	self start.! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 21:35'!
shutDown: quitting
	quitting ifTrue: [ self stop. ]! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 2/29/2012 17:31'!
start
	| delay |
	self finished ifFalse: [ self error: 'An event loop is already running!!' ].
	shouldFinish := false.
	delay := Delay forMilliseconds: 10.
	process := [
	self finished: false.
	[shouldFinish] whileFalse: [ 
		GtkLibrary uniqueInstance eventsPending 
			ifTrue: [ [ GtkLibrary uniqueInstance mainIterationDo: false. ] on: Error do: [ self halt ] ]
			ifFalse: [ delay wait. ]] .
	 self finished: true.
	]
	forkNamed: 'GTKMainLoop'.
	process suspend.
	process priority: 30.
	process resume.
	
	Smalltalk addToStartUpList: self after: Alien.
	Smalltalk addToShutDownList: self.! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2012 09:00'!
startIfNeeded
	self isRunning 
		ifFalse: [ self start ]! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 21:29'!
startUp
	GtkLibrary reset.
	GtkLibrary uniqueInstance init.! !

!GtkEventLoop class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/27/2012 22:47'!
stop
	shouldFinish := true.
	process ifNotNil: [ process terminate ].
	process := nil.! !

Object subclass: #GtkLayout
	instanceVariableNames: 'homogeneus spacing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Layouts'!

!GtkLayout commentStamp: 'NicolasPasserini 2/5/2012 15:50' prior: 0!
Layuts are not GtkObjects since they have no actual representation on the gtk side. 
A layout is translated to a GtkVBox or GtkHBox, which are GtkObjects.!

GtkLayout subclass: #GtkHorizontalLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Layouts'!

!GtkHorizontalLayout methodsFor: 'private' stamp: 'NicolasPasserini 2/5/2012 15:54'!
gtkFactoryFunctionName
	^ 'gtk_hbox_new'! !

!GtkHorizontalLayout methodsFor: 'private' stamp: 'GuillermoPolito 2/17/2012 11:18'!
gtkFixedFactoryFunctionName
	^ 'gtk_hbox_new'! !

!GtkHorizontalLayout methodsFor: 'private' stamp: 'GuillermoPolito 2/17/2012 11:18'!
gtkSplittedFactoryFunctionName
	^ 'gtk_hpaned_new'! !

!GtkLayout class methodsFor: 'instance creation' stamp: 'NicolasPasserini 2/3/2012 19:34'!
horizontal
	^ GtkHorizontalLayout new.! !

!GtkLayout class methodsFor: 'instance creation' stamp: 'NicolasPasserini 2/3/2012 19:34'!
vertical
	^ GtkVerticalLayout new.! !

!GtkLayout methodsFor: 'applying' stamp: 'GuillermoPolito 2/29/2012 16:49'!
applyLayout: aLayoutContainer
	| box |
	box := self gtkCreateBox.
	box gtkAddToContainer: aLayoutContainer.
	aLayoutContainer children do: [:child | child showIn: box ].! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/17/2012 11:20'!
gtkCreateBox
	^self gtkCreateContainerFor: self gtkFixedFactoryFunctionName! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/29/2012 16:24'!
gtkCreateContainerFor: aFunctionName
	| result |
	result := Alien new: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: aFunctionName)
		primFFICallResult: result
		with: self homogeneus asAlien
		with: self spacing.
	^GtkRawContainer handle: result.	! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/17/2012 11:20'!
gtkCreateSplittedBox
	^self gtkCreateContainerFor: self gtkSplittedFactoryFunctionName! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'NicolasPasserini 2/5/2012 15:45'!
gtkFactoryFunctionName
	self subclassResponsibility.! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/17/2012 11:18'!
gtkFixedFactoryFunctionName
	self subclassResponsibility.! !

!GtkLayout methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/17/2012 11:18'!
gtkSplittedFactoryFunctionName
	self subclassResponsibility.! !

!GtkLayout methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 16:16'!
homogeneus
	^ homogeneus ifNil: [ homogeneus := false ]! !

!GtkLayout methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 15:53'!
homogeneus: anObject
	homogeneus := anObject! !

!GtkLayout methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 16:16'!
spacing
	^ spacing ifNil: [ spacing := 5 ]! !

!GtkLayout methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 15:53'!
spacing: anObject
	spacing := anObject! !

GtkLayout subclass: #GtkVerticalLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Layouts'!

!GtkVerticalLayout methodsFor: 'instance creation' stamp: 'NicolasPasserini 2/5/2012 15:54'!
gtkFactoryFunctionName
	^ 'gtk_vbox_new'! !

!GtkVerticalLayout methodsFor: 'instance creation' stamp: 'GuillermoPolito 2/17/2012 11:17'!
gtkFixedFactoryFunctionName
	^ 'gtk_vbox_new'! !

!GtkVerticalLayout methodsFor: 'instance creation' stamp: 'GuillermoPolito 2/17/2012 11:17'!
gtkSplittedFactoryFunctionName
	^ 'gtk_vpaned_new'! !

Object subclass: #GtkObject
	instanceVariableNames: 'callbackRegister handle'
	classVariableNames: ''
	poolDictionaries: 'GtkConstants'
	category: 'Mars-Gtk'!

GtkObject subclass: #GtkEntryBuffer
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-TextHandling'!

!GtkEntryBuffer class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 17:42'!
handle: aGtkHandle entry: anEntry
	^self new
		handle: aGtkHandle;
		entry: anEntry;
		initializeEventHandlers;
		yourself! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:26'!
deletedTextAt: position ofAmmount: ammountOfChars
	entry textHasChanged! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 17:42'!
entry: aGtkEntry
	entry := aGtkEntry! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:05'!
handle
	^handle! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 17:29'!
handle: aGtkHandle
	handle := aGtkHandle! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:03'!
initializeEventHandlers
	self onSignal: 'deleted-text'
		callback: (GtkCallback
			signature: 'void (*)(void *, int, int)'
			block: [ :buffer :position :ammountOfChars | self deletedTextAt: position ofAmmount: ammountOfChars ] )
		data: (Alien newC:4).
		
	self onSignal: 'inserted-text'
		callback: (GtkCallback
			signature: 'void (*)(void *, int, char *)'
			block: [ :buffer :position :text | self insertedText: text at: position. ] )
		data: (Alien newC:4).! !

!GtkEntryBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:23'!
insertedText: text at: position
	entry textHasChanged! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 15:53'!
getIntPropertyNamed: aPropertyName
	| res |
	res := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'g_object_get')
		primFFICallResult: 0
		with: self handle
		with: aPropertyName asAlien pointer
		with: res
		with: 0.
	^res asUnsignedInt.! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 15:53'!
getObjectPropertyNamed: aPropertyName
	| res |
	res := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'g_object_get')
		primFFICallResult: 0
		with: self handle
		with: aPropertyName asAlien pointer
		with: res
		with: 0.
	^res! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 15:53'!
getStringPropertyNamed: aPropertyName
	| res |
	res := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'g_object_get')
		primFFICallResult: 0
		with: self handle
		with: aPropertyName asAlien pointer
		with: res
		with: 0.
	^(Alien atAddress: (res unsignedLongAt: 1) dataSize: (res strlenThroughPointerAt: 1) + 1) strcpy! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/3/2012 19:41'!
handle
	^handle! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/3/2012 19:41'!
handle: aGtkHandle
	handle := aGtkHandle! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 17:31'!
onSignal: event callback: callback data: data
	
	GtkLibrary uniqueInstance
		signalConnectWidget: self handle
		event: event
		callback: callback
		data: data.
		
	self 
		registerCallback: callback 
		forEvent: event.! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/27/2012 22:05'!
onSignal: event for: aWidgetHandle callback: callback data: data
	
	GtkLibrary uniqueInstance
		signalConnectWidget: aWidgetHandle
		event: event
		callback: callback
		data: data.
		
	self 
		registerCallback: callback 
		forEvent: event.! !

!GtkObject methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 17:32'!
registerCallback: anAlienCallback forEvent: event
	"Naive registration"
	(callbackRegister ifNil: [ callbackRegister := Set new ]) add: { event . anAlienCallback }.! !

GtkObject subclass: #GtkTextBuffer
	instanceVariableNames: 'textView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-TextHandling'!

!GtkTextBuffer class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 22:18'!
handle: aGtkHandle textView: aGtkTextView
	^self new
		handle: aGtkHandle;
		textView: aGtkTextView;
		initializeEventHandlers;
		yourself! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:35'!
getEndIter
	| iterator |
	iterator := GtkTextIterator newGC.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_buffer_get_end_iter')
		primFFICallResult: nil asAlien
		with: self handle
		with: iterator pointer.
	^iterator! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:35'!
getIterAtOffset: offset
	| iterator |
	iterator := GtkTextIterator newGC.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_buffer_get_iter_at_offset')
		primFFICallResult: 0
		with: self handle
		with: iterator pointer
		with: offset.
	^iterator! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:40'!
getStartIter
	| iterator |
	iterator := GtkTextIterator newGC.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_buffer_get_start_iter')
		primFFICallResult: nil asAlien
		with: self handle
		with: iterator pointer.
	^iterator! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:58'!
getText
	^self getTextBetween: self getStartIter and: self getEndIter.! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/30/2012 18:06'!
getTextBetween: aStartIter and: anEndIter
	| res |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_buffer_get_text')
		primFFICallResult: res
		with: self handle
		with: aStartIter pointer
		with: anEndIter pointer
		with: 0.
	^res asString! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 19:43'!
handle
	^handle! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:40'!
handle: aGtkHandle
	handle := aGtkHandle! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/20/2012 01:07'!
initializeEventHandlers
	self onSignal: 'changed'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: [ :buffer :data | self textChanged ] )
		data: (Alien newC:4).! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/30/2012 16:58'!
text: aString
	| alien |
	(alien := aString asAlien) releaseAfter: [
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_buffer_set_text')
			primFFICallResult: 0
			with: self handle
			with: alien pointer
			with: aString size
	]! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:48'!
textChanged
	textView textChanged! !

!GtkTextBuffer methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:41'!
textView: aGtkTextView
	textView := aGtkTextView! !

GtkObject subclass: #GtkWidget
	uses: TGtkWidget
	instanceVariableNames: 'model parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

GtkWidget class
	uses: TGtkWidget classTrait
	instanceVariableNames: ''!

GtkWidget subclass: #GtkButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkButton class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/30/2012 23:16'!
new
	^self handle: ((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_button_new')
		primFFICallResult: (Alien new: 4))! !

!GtkButton methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 23:17'!
label: aString
	aString asAlien releaseAfter: [ :labelAlien |
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_button_set_label')
			primFFICallResult: 0
			with: self handle
			with: labelAlien pointer
	]! !

!GtkButton methodsFor: 'eventHandling' stamp: 'GuillermoPolito 1/30/2012 23:20'!
onClick: anActionBlock
	self 
		onSignal: 'clicked' 
		callback: (GtkCallback  
			signature: 'void (*)(void)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

GtkWidget subclass: #GtkContainer
	uses: TGtkContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

GtkContainer class
	uses: TGtkContainer classTrait
	instanceVariableNames: ''!

!GtkContainer methodsFor: 'adding' stamp: 'GuillermoPolito 2/29/2012 17:09'!
add: aChild
	self children add: aChild! !

!GtkContainer methodsFor: 'adding' stamp: 'GuillermoPolito 2/29/2012 17:10'!
addChild: aChild
	self children add: aChild.! !

!GtkContainer methodsFor: 'accessing' stamp: 'GuillermoPolito 2/29/2012 17:09'!
children
	^children! !

!GtkContainer methodsFor: 'initialize-release' stamp: 'GuillermoPolito 2/29/2012 17:10'!
initialize
	super initialize.
	children := OrderedCollection new! !

GtkContainer subclass: #GtkLayoutContainer
	instanceVariableNames: 'layoutPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkLayoutContainer methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 16:12'!
layoutPolicy
	^ layoutPolicy! !

!GtkLayoutContainer methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 16:12'!
layoutPolicy: anObject
	layoutPolicy := anObject
! !

!GtkLayoutContainer methodsFor: 'rendering' stamp: 'NicolasPasserini 2/6/2012 09:18'!
showIn: aContainer
	super showIn: aContainer.
	self layoutPolicy applyLayout: self.! !

GtkLayoutContainer subclass: #GtkPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkPanel class methodsFor: 'gtk-api-constructors' stamp: 'NicolasPasserini 2/5/2012 16:23'!
new
	| result |
	result := Alien new: 4.
	
	"Gtk does not have a direct translation for a panel, so use a vbox."
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_vbox_new')
		primFFICallResult: result
		with: true asAlien  "Homogeneous... does not really care, as it will have only one child"
		with: 0.  "No spacing"
	^self handle: result.! !

GtkLayoutContainer subclass: #GtkWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkWindow class methodsFor: 'gtk-api-constructors' stamp: 'GuillermoPolito 1/30/2012 16:53'!
new
	| result |
	result := Alien new: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_new')
		primFFICallResult: result
		with: 0.
	^self handle: result.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:11'!
activateDefault
	| res |
	res := Alien new: 1.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_activate_default')
		primFFICallResult: res
		with: self handle.
	^res asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:11'!
activateFocus
	| res |
	res := Alien new: 1.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_activate_focus')
		primFFICallResult: res
		with: self handle.
	^res asSignedByte > 0! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:11'!
decorated
	((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_decorated')
		primFFICallResult: (Alien new: 4)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:05'!
decorated: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_decorated')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:11'!
default: aGtkWidgetHandle
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_default')
		primFFICallResult: (Alien new: 4)
		with: self handle
		with: aGtkWidgetHandle! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:07'!
defaultHeight
	^self defaultSize y! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:11'!
defaultSize
	| width height |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_default_size')
		primFFICallResult: 0
		with: self handle
		with: (width := Alien new: 4)
		with: (height := Alien new: 4).
	^width asSignedLong @ height asSignedLong! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
defaultWidget
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_default_widget')
		primFFICallResult: (Alien new: 4)
		with: self handle! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:07'!
defaultWidth
	^self defaultSize x! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/20/2012 01:04'!
defaultWidth: aWidth height: aHeight
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_default_size')
		primFFICallResult: 0
		with: self handle
		with: aWidth
		with: aHeight! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
deiconify
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_deiconify')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
deletable
	((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_deletable')
		primFFICallResult: (Alien new: 4)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:05'!
deletable: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_deletable')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
destroyWithParent
	^((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_destroy_with_parent')
		primFFICallResult: (Alien new: 4)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:08'!
destroyWithParent: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_destroy_with_parent')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'NicolasPasserini 2/3/2012 11:53'!
extent: aPoint
	| aWidth |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_default_size')
		primFFICallResult: 0
		with: self handle
		with: aPoint x
		with: aPoint y! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
focus
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_focus')
		primFFICallResult: (Alien new: 4)
		with: self handle! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:15'!
focus: aGtkWidgetHandle
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_focus')
		primFFICallResult: 0
		with: self handle
		with: aGtkWidgetHandle! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
fullscreen
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_fullscreen')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
group
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_group')
		primFFICallResult: (Alien new: 4)
		with: self handle! !

!GtkWindow methodsFor: 'gtk-private' stamp: 'GuillermoPolito 2/29/2012 16:21'!
gtkAddToContainer: aGtkContainer
	"I'm a Window, I do not belong to any container"! !

!GtkWindow methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 20:11'!
handleClicks
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_add_events')
		primFFICallResult: 0
		with: self handle
		with: 1<<8.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:12'!
hasGroup
	^((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_has_group')
		primFFICallResult: (Alien new: 4)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
hasToplevelFocus 
	| res |
	res := Alien new: 1.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_has_toplevel_focus')
		primFFICallResult: res
		with: self handle.
	^res asSignedByte > 0! !

!GtkWindow methodsFor: 'accessing' stamp: 'GuillermoPolito 2/16/2012 17:56'!
height
	^self size y! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
iconify
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_iconify')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 19:50'!
initialize
	super initialize.
	self handleClicks.
	GtkLibrary uniqueInstance registerWidget: self.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
isActive
	| res |
	res := Alien new: 1.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_is_active')
		primFFICallResult: res
		with: self handle.
	^res asSignedByte > 0! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:04'!
keepAbove: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_keep_above')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:04'!
keepBelow: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_keep_below')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'accessing' stamp: 'NicolasPasserini 2/3/2012 15:08'!
layoutPolicy
	^ layoutPolicy! !

!GtkWindow methodsFor: 'accessing' stamp: 'NicolasPasserini 2/3/2012 15:08'!
layoutPolicy1: anObject
	layoutPolicy := anObject! !

!GtkWindow methodsFor: 'accessing' stamp: 'NicolasPasserini 2/3/2012 15:08'!
layoutPolicy: anObject
	layoutPolicy := anObject
! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
maximize
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_maximize')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
modal
	((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_modal')
		primFFICallResult: (Alien new: 1)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:04'!
modal: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_modal')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:26'!
movetoX: anXCoord andY: anYCoord
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_move')
		primFFICallResult: 0
		with: self handle
		with: anXCoord
		with: anYCoord! !

!GtkWindow methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/19/2012 23:32'!
onActivateDefault: anActionBlock
	self 
		onSignal: 'activate-default' 
		callback:  (GtkCallback
			signature: 'void (*)(void *)'
			block: anActionBlock)
		data: (Alien newC: 4)! !

!GtkWindow methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/19/2012 23:34'!
onActivateFocus: anActionBlock
	self 
		onSignal: 'set-focus'
		callback:  (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: anActionBlock)
		data: (Alien newC: 4)! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
opacity
	^((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_opacity')
		primFFICallResult: (Alien new: 8)
		with: self handle) doubleAt: 1! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:29'!
opacity: anOpacity
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_opacity')
		primFFICallResult: 0
		with: self handle
		with: anOpacity! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:10'!
position: aGtkWindowPosition
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_position')
		primFFICallResult: 0
		with: self handle
		with: aGtkWindowPosition! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:12'!
present
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_present')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/19/2012 23:18'!
presentWithTime: milliseconds
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_present_with_time')
		primFFICallResult: 0
		with: self handle
		with: milliseconds! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
resizable
	((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_resizable')
		primFFICallResult: (Alien new: 1)
		with: self handle) asBoolean! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 01:56'!
resizable: aBoolean
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_resizable')
		primFFICallResult: 0
		with: self handle
		with: aBoolean asAlien.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/29/2012 16:17'!
show
	"see show_all"
	self showIn: nil.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_show_all')
		primFFICallResult: (Alien new: 4)
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:13'!
size
	| width height |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_default_size')
		primFFICallResult: 0
		with: self handle
		with: (width := Alien new: 4)
		with: (height := Alien new: 4).
	^width asSignedLong @ height asSignedLong! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
stick
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_stick')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:14'!
title
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_title')
		primFFICallResult: (Alien new: 4)
		with: self handle! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:14'!
title: aTitle
	aTitle asAlien releaseAfter: [ :titleAlien |
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_set_title')
			primFFICallResult: 0
			with: self handle
			with: titleAlien pointer.
	]! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
unfullscreen
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_unfullscreen')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
unmaximize
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_unmaximize')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:14'!
unstick
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_unstick')
		primFFICallResult: 0
		with: self handle.! !

!GtkWindow methodsFor: 'accessing' stamp: 'GuillermoPolito 2/16/2012 17:56'!
width
	^self size x! !

!GtkWindow methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:14'!
windowType
	| width height |
	^((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_window_get_window_type')
		primFFICallResult: (Alien new: 4)
		with: self handle) asSignedLong! !

GtkContainer subclass: #GtkRawContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkRawContainer methodsFor: 'gtk-private' stamp: ''!
gtkAddChild: aWidget
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_container_add')
		primFFICallResult: (Alien new: 4)
		with: self handle
		with: aWidget handle.! !

!GtkRawContainer methodsFor: 'gtk-private' stamp: 'GuillermoPolito 2/29/2012 17:07'!
showIn: aGtkContainer
	super showIn: aGtkContainer.
	self children do: [ :child | child showIn: self ]! !

GtkWidget subclass: #GtkEntry
	uses: GtkEditable
	instanceVariableNames: 'customMenuItems paragraph buffer contentsPropertyBinding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

GtkEntry class
	uses: GtkEditable classTrait
	instanceVariableNames: ''!

!GtkEntry class methodsFor: 'gtk-api-constructors' stamp: 'GuillermoPolito 1/20/2012 18:20'!
new
	^self handle: ((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_entry_new')
		primFFICallResult: (Alien newC: 4))! !

!GtkEntry methodsFor: 'menu-building' stamp: 'GuillermoPolito 1/18/2012 14:47'!
appendMenuItem: aGtkMenuItem
	self customMenuItems add: aGtkMenuItem.! !

!GtkEntry methodsFor: 'binding' stamp: 'GuillermoPolito 1/30/2012 17:56'!
bindContentsOn: aProperty
	contentsPropertyBinding := aProperty! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/18/2012 15:43'!
cursorPosition
	^self getIntPropertyNamed: 'cursor-position'! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/18/2012 14:48'!
customMenuItems
	^customMenuItems! !

!GtkEntry methodsFor: 'private' stamp: 'GuillermoPolito 1/19/2012 17:28'!
getBuffer
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_entry_get_buffer')
		primFFICallResult: (Alien newC:4)
		with: self handle.! !

!GtkEntry methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/19/2012 17:43'!
initialize
	super initialize.
	self onSignal: 'populate-popup' 
		callback:  (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: [:widget :menu |
				self populateMenu: menu asGtkMenu ])
		data: (Alien newC: 4).
	buffer := GtkEntryBuffer handle: self getBuffer entry: self.
	customMenuItems := OrderedCollection new.! !

!GtkEntry methodsFor: 'binding' stamp: 'GuillermoPolito 1/19/2012 17:50'!
modelUpdated
	(self model notNil & contentsPropertyBinding notNil) ifTrue: [ self text: (contentsPropertyBinding value: self model)]! !

!GtkEntry methodsFor: 'private' stamp: 'GuillermoPolito 1/18/2012 15:05'!
populateMenu: aGtkMenu
	self customMenuItems 
		do: [ :ea | aGtkMenu append: ea gtkClone show; yourself ]! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 17:06'!
selectedText
	| start end startInt endInt res |
	res := Alien newC: 4.
	start := Alien newC: 4.
	end := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_editable_get_selection_bounds')
		primFFICallResult: res
		with: self handle
		with: start pointer
		with: end pointer.
	res asUnsignedShort > 0 ifTrue: [
		startInt := start asUnsignedLong.
		endInt := end asUnsignedLong.
		^self text copyFrom: startInt + 1 to: endInt
	] ifFalse: [ 
		^'' 
	]! !

!GtkEntry methodsFor: 'private' stamp: 'GuillermoPolito 1/18/2012 15:43'!
selectionBound
	^self getIntPropertyNamed: 'selection-bound'! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 01:13'!
text
	^((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_entry_get_text')
		primFFICallResult: (Alien newC: 4)
		with: self handle) asString! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 17:51'!
text: aString
	| res string startIndex |
	res := Alien newC: 4.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_entry_set_text')
		primFFICallResult: res
		with: self handle
		with: aString asAlien.! !

!GtkEntry methodsFor: 'binding' stamp: 'GuillermoPolito 1/19/2012 18:23'!
textHasChanged
	(self model notNil & contentsPropertyBinding notNil) ifTrue: [ self model perform: contentsPropertyBinding asMutator with: self text ]! !

!GtkEntry methodsFor: 'accessing' stamp: 'GuillermoPolito 1/18/2012 02:42'!
textLength
	| res |
	res := Alien newC: 2.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_entry_get_text_length')
		primFFICallResult: res
		with: self handle.
	^res asUnsignedShort! !

GtkWidget subclass: #GtkList
	instanceVariableNames: 'store list announcer selectionProperty contentsProperty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkList class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/30/2012 16:53'!
new
	| handle |
	handle := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_new')
		primFFICallResult: (Alien new: 4).
	^self handle: handle.! !

!GtkList methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 16:13'!
add: element
	self addAll: { element }! !

!GtkList methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 16:43'!
addAll: aCollectionOfElements
	aCollectionOfElements do: [ :element | 
		| iterator alien |
		
		list add: element.
		
		(iterator := Alien newC: 16) releaseAfter: [
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_list_store_append')
			primFFICallResult: 0
			with: store
			with: iterator pointer.
		
		alien := element asString asAlien.
		alien releaseAfter: [
			(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_list_store_set')
				primFFICallResult: 0
				with: store
				with: iterator pointer
				with: 0
				with: alien pointer
				with: -1
			].
		]
	]! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:11'!
announcer
	^announcer! !

!GtkList methodsFor: 'binding' stamp: 'GuillermoPolito 1/30/2012 17:52'!
bindContentsOn: aProperty
	contentsProperty := aProperty.
	self announcer on: MarsPropertyHasChanged
			do: [ :ann | ann property = aProperty ifTrue: [ self updateContents ] ]! !

!GtkList methodsFor: 'binding' stamp: 'GuillermoPolito 2/29/2012 17:32'!
bindSelectedItemOn: aProperty
	selectionProperty := aProperty.
	self announcer on: MarsPropertyHasChanged
			do: [ :ann | ann property = aProperty ifTrue: [ self updateSelection ] ].
	self onSelectionChanged: [ :selection :data |
			self model 
				perform: aProperty asMutator 
				with: (self selectedObjects ifNotEmpty: [ self selectedObjects first] ifEmpty: [ nil ])
			]! !

!GtkList methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 16:44'!
clear
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_list_store_clear')
		primFFICallResult: 0
		with: store.
		
	list removeAll.! !

!GtkList methodsFor: 'initialize-release' stamp: 'NicolasPasserini 2/2/2012 16:41'!
initialize
	| textRenderer |
	super initialize.
	
	store := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_list_store_new')
		primFFICallResult: (Alien new:4)
		with: 1
		with: 16 << 2.
	textRenderer := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_cell_renderer_text_new')
		primFFICallResult: (Alien new: 4).
	'text' asAlien releaseAfter: [ :attrAlien |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_insert_column_with_attributes')
		primFFICallResult: (Alien new: 4)
		with: self handle
		with: -1
		with: 0
		with: textRenderer
		with: attrAlien pointer
		with: 0
		with: 0.
	].

	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_set_model')
		primFFICallResult: 0
		with: self handle
		with: store.
		
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_set_headers_visible')
		primFFICallResult: 0
		with: self handle
		with: false asAlien.
	
	self onRightClick: [ :widget :event :data | self popUpMenu ].
	
	list := OrderedCollection new.
	announcer := Announcer new.! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 16:43'!
list
	^list! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:52'!
model: anObject
	model := anObject.
	model addAnnouncer: self announcer.! !

!GtkList methodsFor: 'events' stamp: 'GuillermoPolito 1/30/2012 14:40'!
onSelectionChanged: anActionBlock
	| selection |
	selection := self privateSelection.
	self
		onSignal: 'changed' 
		for: selection
		callback: (GtkCallback  
			signature: 'void (*)(void *, void *)'
			block: anActionBlock)
		data: 0.! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 23:24'!
popUpMenu
	"I wrote this as an example only.  We should remove it and delegate it to the selected object if any, or to the model if not"
	self flag: #todo.
	GtkMenu new
		append: (GtkMenuItem new label: 'Try'; onActivate: [ :item :data | Browser open ]; yourself );
		append: (GtkMenuItem new label: 'Try2'; onActivate: [ :item :data | Browser open ]; yourself );
		append: (GtkMenuItem new label: 'Try3'; onActivate: [ :item :data | Browser open ]; yourself );
		show! !

!GtkList methodsFor: 'private' stamp: 'GuillermoPolito 1/30/2012 14:18'!
privateSelection
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_get_selection')
		primFFICallResult: (Alien new: 4)
		with: self handle.! !

!GtkList methodsFor: 'private' stamp: 'GuillermoPolito 1/30/2012 22:51'!
selectIndex: anIndex
	| iterator |
	anIndex <= 0 ifTrue: [^self].
	(iterator := Alien newC: 16) releaseAfter: [
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_model_iter_nth_child')
			primFFICallResult: 0
			with: store
			with: iterator pointer
			with: 0
			with: anIndex - 1.
	]
! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 19:56'!
selectObject: anObject
	self selectIndex: (list indexOf: anObject).! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 16:42'!
selectedObjects
	^self selectedRowIndexes collect: [ :i | self list at: i ].! !

!GtkList methodsFor: 'private' stamp: 'GuillermoPolito 1/30/2012 16:15'!
selectedRowIndexes
	| selectedRowIndexes selection list cb |
	selectedRowIndexes := OrderedCollection new.
	selection := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_view_get_selection')
		primFFICallResult: (Alien new: 4)
		with: self handle.
	cb := (GtkCallback signature: 'void (*)(void *, void *, void *)'
			block: [ :tree_model :path :iterator  |
					| size  indexes |
					indexes := Alien new: 4.
					(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_path_get_indices')
						primFFICallResult: indexes
						with: path.
					selectedRowIndexes add: ( (Alien forPointer: (indexes asUnsignedLong)) unsignedLongAt: 1) + 1. "Smalltalk is base 1 :)"
				]).
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_tree_selection_selected_foreach')
		primFFICallResult: 0
		with: selection
		with: cb thunk
		with: 0. "data"
	^selectedRowIndexes.! !

!GtkList methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 17:36'!
setContents: someContents
	self clear.
	self addAll: someContents! !

!GtkList methodsFor: 'gtk-private' stamp: 'GuillermoPolito 2/29/2012 17:45'!
showIn: aGtkContainer
	| scrollPanel |
	scrollPanel := GtkScrollPanel new.
	self gtkAddToContainer: scrollPanel.
	scrollPanel gtkAddToContainer: aGtkContainer.! !

!GtkList methodsFor: 'binding' stamp: 'GuillermoPolito 2/29/2012 17:36'!
updateContents
	self setContents: (model perform: contentsProperty).! !

!GtkList methodsFor: 'binding' stamp: 'GuillermoPolito 1/30/2012 17:26'!
updateSelection
	self selectObject: (model perform: selectionProperty)! !

GtkWidget subclass: #GtkMenuShell
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Menues'!

GtkMenuShell subclass: #GtkMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Menues'!

GtkMenu class
	instanceVariableNames: 'instances'!

GtkMenu class
	instanceVariableNames: 'instances'!

!GtkMenu class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/30/2012 19:25'!
new
	^self handle: ((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_new')
		primFFICallResult: (Alien new: 4))! !

!GtkMenu class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/30/2012 22:32'!
registerInstance: anInstance
	(instances ifNil: [ instances := Set new ]) add: anInstance.! !

!GtkMenu methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 23:42'!
initialize 
	super initialize.
	"so it's not garbage collected.  We have to improve this..."
	self flag: #todo.
	GtkMenu registerInstance: self.! !

GtkMenuShell subclass: #GtkMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Menues'!

!GtkMenuItem class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/30/2012 19:25'!
new
	^self handle: ((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_item_new')
		primFFICallResult: (Alien new: 4))! !

!GtkMenuItem methodsFor: 'private' stamp: 'GuillermoPolito 1/30/2012 19:26'!
gtkClone
	| clone |
	clone := self class new
		label: self label;
		yourself.
		
	callbackRegister do: [ :array | clone onSignal: array first callback: array second data: 0 ].
	
	^clone
		! !

!GtkMenuItem methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 19:26'!
label
	| res |
	res := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_item_get_label')
		primFFICallResult: (Alien new: 4)
		with: self handle.
	^(Alien atAddress: (res unsignedLongAt: 1) dataSize: (res strlenThroughPointerAt: 1) + 1) strcpy! !

!GtkMenuItem methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 19:26'!
label: aLabelString
	aLabelString asAlien releaseAfter: [ :alien |
		(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_item_set_label')
			primFFICallResult: (Alien new: 4)
			with: self handle
			with: alien pointer.
	]! !

!GtkMenuItem methodsFor: 'events' stamp: 'GuillermoPolito 1/30/2012 22:27'!
onActivate: anActionBlock
	self 
		onSignal: 'activate' 
		callback:  (GtkCallback 
			signature: 'void (*)(void *, void *)'
			block: anActionBlock)
		data: 0! !

!GtkMenuShell methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 22:20'!
append: aMenuItem
	"Adds a new GtkMenuItem to the end of the menu shell's item list."
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_shell_append')
		primFFICallResult: 0
		with: self handle
		with: aMenuItem handle.
		
	items add: aMenuItem.! !

!GtkMenuShell methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 22:20'!
initialize 
	super initialize.
	items := OrderedCollection new.! !

!GtkMenuShell methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 22:21'!
insert: aMenuItem at: aZeroBasedPosition
	"Adds a new GtkMenuItem to the beginning of the menu shell's item list."
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_shell_prepend')
		primFFICallResult: 0
		with: self handle
		with: aMenuItem handle
		with: aZeroBasedPosition.
		
	items add: aMenuItem! !

!GtkMenuShell methodsFor: 'adding' stamp: 'GuillermoPolito 1/30/2012 22:21'!
prepend: aMenuItem
	"Adds a new GtkMenuItem to the beginning of the menu shell's item list."
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_shell_prepend')
		primFFICallResult: 0
		with: self handle
		with: aMenuItem handle.
	
	items add: aMenuItem! !

!GtkMenuShell methodsFor: 'showing' stamp: 'GuillermoPolito 1/30/2012 23:44'!
show
	| timestamp |
	
	super show. "we show the childs"
	
	timestamp := ((GtkLibrary uniqueInstance alienMethodNamed: 'gtk_get_current_event_time')
		primFFICallResult: (Alien new: 4)) asUnsignedLong.
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_menu_popup')
		primFFICallResult: 0
		with: self handle
		with: 0
		with: 0
		with: 0
		with: 0
		with: 3
		with: timestamp.! !

GtkWidget subclass: #GtkScrollPanel
	uses: TGtkContainer + TGtkWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

GtkScrollPanel class
	uses: TGtkContainer classTrait + TGtkWidget classTrait
	instanceVariableNames: ''!

!GtkScrollPanel class methodsFor: 'as yet unclassified' stamp: 'pnp 2/2/2012 13:35'!
new
	| handle |
	handle := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_scrolled_window_new')
		primFFICallResult: (Alien new: 4)
		with: 0
		with: 0.
	^self handle: handle.! !

!GtkScrollPanel methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 16:21'!
initialize
	super initialize.
	self setPolicyHorizontal: PolicyTypeAutomatic  
		vertical: PolicyTypeAutomatic. 
! !

!GtkScrollPanel methodsFor: 'as yet unclassified' stamp: 'NicolasPasserini 2/2/2012 14:51'!
setPolicyHorizontal: horizontalPolicy vertical: verticalPolicy
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_scrolled_window_set_policy')
		primFFICallResult: nil asAlien
		with: self handle
		with: horizontalPolicy
		with: verticalPolicy.
! !

GtkWidget subclass: #GtkTextArea
	instanceVariableNames: 'buffer contentBinding announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

!GtkTextArea class methodsFor: 'gtk-api-constructors' stamp: 'GuillermoPolito 1/30/2012 16:53'!
new
	| handle |
	handle := (GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_view_new')
		primFFICallResult: (Alien new: 4).
	^self handle: handle.! !

!GtkTextArea methodsFor: 'bindings' stamp: 'GuillermoPolito 1/30/2012 18:01'!
announcer
	^announcer! !

!GtkTextArea methodsFor: 'bindings' stamp: 'GuillermoPolito 1/30/2012 17:59'!
bindContentsOn: aProperty
	contentBinding := aProperty.
	self announcer on: MarsPropertyHasChanged
		do: [ :ann | ann property = aProperty ifTrue: [ self updateContents ] ]! !

!GtkTextArea methodsFor: 'accessing' stamp: 'GuillermoPolito 1/20/2012 01:11'!
buffer
	^ buffer! !

!GtkTextArea methodsFor: 'private' stamp: 'GuillermoPolito 1/30/2012 16:53'!
getBuffer
	^(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_text_view_get_buffer')
		primFFICallResult: (Alien new: 4)
		with: self handle! !

!GtkTextArea methodsFor: 'initialize-release' stamp: 'GuillermoPolito 1/30/2012 18:00'!
initialize
	super initialize.
	buffer := GtkTextBuffer handle: self getBuffer textView: self.
	announcer := Announcer new.! !

!GtkTextArea methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 18:00'!
model: anObject
	model := anObject.
	model addAnnouncer: announcer.! !

!GtkTextArea methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 16:59'!
text
	^self buffer getText! !

!GtkTextArea methodsFor: 'accessing' stamp: 'GuillermoPolito 1/30/2012 18:14'!
text: aString
	self text = aString ifTrue: [^self].
	^self buffer text: aString! !

!GtkTextArea methodsFor: 'bindings' stamp: 'GuillermoPolito 1/30/2012 16:59'!
textChanged
	model notNil & contentBinding notNil ifTrue: [ model perform: contentBinding asMutator with: self text ]! !

!GtkTextArea methodsFor: 'bindings' stamp: 'GuillermoPolito 1/30/2012 18:14'!
updateContents
	self text: (model perform: contentBinding)! !

!GtkWidget class methodsFor: 'instance creation' stamp: 'GuillermoPolito 1/20/2012 01:05'!
handle: aGtkHandle
	^self basicNew
		handle: aGtkHandle;
		initialize;
		yourself! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:16'!
destroy
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_destroy')
		primFFICallResult: (Alien new: 4)
		with: self handle.! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/16/2012 18:01'!
extent: aSize
	self width: aSize x height: aSize y! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 16:41'!
height: aHeight
	self width: -1 height: aHeight! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/18/2012 02:18'!
hide
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_hide')
		primFFICallResult: (Alien new: 4)
		with: self handle.! !

!GtkWidget methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 17:45'!
model
	^model! !

!GtkWidget methodsFor: 'accessing' stamp: 'GuillermoPolito 1/19/2012 17:45'!
model: aModel
	model := aModel! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/30/2012 19:18'!
onButtonPressEvent: anActionBlock
	self onSignal: 'button-press-event' 
		callback: (GtkCallback
			signature: 'void (*)(void *, eventButton *, void *)'
			block: anActionBlock )
		data: 0! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:18'!
onButtonReleaseEvent: anActionBlock
	self onSignal: 'button-release-event' 
		callback: (GtkCallback
			signature: 'void (*)(void *, eventButton *, void *)'
			block: [ :widget :event :data |
				anActionBlock 
					cull: widget 
					cull: event 
					cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:21'!
onCompositeChanged: anActionBlock
	self onSignal: 'composited-changed' 
		callback: (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: [ :widget :data |
				anActionBlock 
					cull: widget 
					cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:22'!
onConfigureEvent: anActionBlock
	self onSignal: 'configure-event'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *, void *)'
			block: [ :widget :event :data |
				anActionBlock 
					cull: widget 
					cull: event 
					cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 18:47'!
onDeleteEvent: anActionBlock
	self onSignal: 'delete-event'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, void *)'
			block: anActionBlock )
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:28'!
onDirectionChanged: anActionBlock
	self onSignal: 'direction-changed' 
		callback: (GtkCallback
			signature: 'void (*)(void *, int, void *)'
			block: [ :widget :event :data |
				anActionBlock 
					cull: widget 
					cull: event 
					cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:27'!
onDragBegin: anActionBlock
	self onSignal: 'drag-begin'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *, void *)'
			block: [ :widget :event :data |
				anActionBlock 
					cull: widget 
					cull: event 
					cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onDragDrop: anActionBlock
	self onSignal: 'drag-drop'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, int, int, int, void *)'
			block: [ :widget :dragContext :x :y :time :data | anActionBlock valueWithArguments: { widget . dragContext . x . y . time . data } ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onDragEnd: anActionBlock
	self onSignal: 'drag-end'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *, void *)'
			block: [ :widget :dragContext :data | anActionBlock cull: widget cull: dragContext cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onDragFailed: anActionBlock
	self onSignal: 'drag-failed'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, int, void *)'
			block: [ :widget :dragContext :result :data | anActionBlock cull: widget cull: dragContext cull: result cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onDragLeave: anActionBlock
	self onSignal: 'drag-leave'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *, int, void *)'
			block: [ :widget :dragContext :time :data | anActionBlock cull: widget cull: dragContext cull: time cull: data ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onDragMotion: anActionBlock
	self onSignal: 'drag-motion'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, int, int, int, void *)'
			block: [ :widget :dragContext :x :y :time :data | anActionBlock valueWithArguments: { widget . dragContext . x . y. time . data } ])
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:51'!
onFocus: anActionBlock
	self onSignal: 'focus'
		callback: (GtkCallback
			signature: 'int (*)(void *, int, void *)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:52'!
onFocusInEvent: anActionBlock
	self onSignal: 'focus-in-event'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, void *)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:53'!
onFocusOutEvent: anActionBlock
	self onSignal: 'focus-out-event'
		callback: (GtkCallback
			signature: 'int (*)(void *, void *, void *)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:55'!
onHide: anActionBlock
	self onSignal: 'hide'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/30/2012 19:18'!
onPopUpMenu: anActionBlock
	self onSignal: 'popup-menu'
		callback: (GtkCallback
			signature: 'int (*)(void *, int, void *)'
			block: anActionBlock)
		data: 0.! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/30/2012 22:51'!
onRightClick: anActionBlock
	self onSignal: 'button-press-event' 
		callback: (GtkCallback
			signature: 'int (*)(void *, eventButton *, void *)'
			block: [ :widget :event :data | 
				Transcript show: ('event type: {1} button: {2}' format: { event eventType . event button}); cr.
				event eventType = 4 & event button = 3
					ifTrue: [[anActionBlock value: widget value: event value: data] on: Error do: [ ] ].
					false asAlien ] )
		data: 0! !

!GtkWidget methodsFor: 'gtk-events' stamp: 'GuillermoPolito 1/20/2012 00:56'!
onShow: anActionBlock
	self onSignal: 'show'
		callback: (GtkCallback
			signature: 'void (*)(void *, void *)'
			block: anActionBlock)
		data: (Alien newC: 4).! !

!GtkWidget methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 09:14'!
parent
	^ parent! !

!GtkWidget methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 09:14'!
parent: anObject
	parent := anObject! !

!GtkWidget methodsFor: 'decorations' stamp: 'NicolasPasserini 2/2/2012 14:38'!
scrollable
	^ GtkScrollPanel new addChild: self; yourself.! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 14:45'!
show
	"see show_all"
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_show_all')
		primFFICallResult: (Alien new: 4)
		with: self handle.! !

!GtkWidget methodsFor: 'rendering' stamp: 'GuillermoPolito 2/29/2012 16:19'!
showIn: aGtkContainer
	self gtkAddToContainer: aGtkContainer.
	"Here subclasses can add the behavior needed before beeing shown on screen"! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 16:41'!
width: aWidth
	self width: aWidth height: -1! !

!GtkWidget methodsFor: 'gtk-api' stamp: 'GuillermoPolito 1/30/2012 16:39'!
width: aWidth height: aHeight
	| requisition |
	(GtkLibrary uniqueInstance alienMethodNamed: 'gtk_widget_set_size_request')
		primFFICallResult: 0
		with: self handle
		with: aWidth
		with: aHeight! !

Object subclass: #GtkSplitter
	uses: TGtkWidget + TGtkContainer
	instanceVariableNames: 'layoutPolicy children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Widgets'!

GtkSplitter class
	uses: TGtkWidget classTrait + TGtkContainer classTrait
	instanceVariableNames: ''!

!GtkSplitter methodsFor: 'adding' stamp: 'GuillermoPolito 2/16/2012 17:52'!
add: aGtkWidget
	self addChild: aGtkWidget! !

!GtkSplitter methodsFor: 'adding' stamp: 'NicolasPasserini 2/6/2012 12:27'!
addChild: aGtkWidget
	self children add: aGtkWidget.! !

!GtkSplitter methodsFor: 'configuration' stamp: 'NicolasPasserini 2/6/2012 12:24'!
beHorizontal
	self layoutPolicy: MLayout horizontal.! !

!GtkSplitter methodsFor: 'configuration' stamp: 'NicolasPasserini 2/6/2012 12:46'!
beVertical
	self layoutPolicy: MLayout vertical.! !

!GtkSplitter methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 12:25'!
children
	^ children! !

!GtkSplitter methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 12:25'!
children: anObject
	children := anObject! !

!GtkSplitter methodsFor: 'gtk-api' stamp: 'GuillermoPolito 2/17/2012 11:32'!
gtkCreateBox
	^ self layoutPolicy gtkCreateSplittedBox.! !

!GtkSplitter methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 12:39'!
handle
	^ box handle! !

!GtkSplitter methodsFor: 'initialize-release' stamp: 'NicolasPasserini 2/6/2012 12:26'!
initialize 
	super initialize.
	children := OrderedCollection new.! !

!GtkSplitter methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 12:24'!
layoutPolicy
	^ layoutPolicy! !

!GtkSplitter methodsFor: 'accessing' stamp: 'NicolasPasserini 2/6/2012 12:24'!
layoutPolicy: anObject
	layoutPolicy := anObject! !

!GtkSplitter methodsFor: 'rendering' stamp: 'GuillermoPolito 2/29/2012 17:19'!
showIn: aContainer
	| currentBox newBox |
	(self children reversed reduce: [ :box :child | 
		self gtkCreateBox add: child; add: box; yourself.
	]) showIn: aContainer.! !

Object subclass: #GtkWorkspace
	instanceVariableNames: 'workspace editor textbox window contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Gtk-Tools'!

!GtkWorkspace class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 15:47'!
open
	^self new open! !

!GtkWorkspace methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:12'!
contents
	^contents! !

!GtkWorkspace methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:12'!
contents: aText
	contents := aText! !

!GtkWorkspace methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/18/2012 16:00'!
doIt
	| selectedText |
	selectedText := textbox selectedText.
	[
		nil class evaluatorClass new 
			evaluate: textbox selectedText
			in: nil
			to: nil
			notifying: nil
			ifFail: [ ^nil ]
			logged: false.
		] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].! !

!GtkWorkspace methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/19/2012 18:13'!
initialize
	contents := 'workspace initial contents'! !

!GtkWorkspace methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/30/2012 17:56'!
open
	window := GtkWindow new.
	textbox := GtkEntry new.
	textbox model: self.
	textbox bindContentsOn: #contents.
	textbox appendMenuItem: (GtkMenuItem new label: 'Do It'; onActivate: [ self doIt ]; yourself).
	window addChild: textbox.
	window show.! !

!Object methodsFor: '*Mars-Gtk' stamp: 'GuillermoPolito 1/30/2012 13:48'!
release
	"hook for objects that handle external resources"! !

!Object methodsFor: '*Mars-Gtk' stamp: 'GuillermoPolito 1/30/2012 13:48'!
releaseAfter: aBlock
	[ aBlock cull: self ] ensure: [ self release ]! !
GtkConstants initialize!
